//	A1.6.- usart
//	Autores: Jess Mara Corres, Carlos Ruiz Zamarreo y Cndido Bariin
//	Pamplona, Agosto 2016

#ifndef _SERIAL_H_
#define _SERIAL_H_
#define HIGH_SPEED 			0x04			// Modo alta velocidad
#define LOW_SPEED 			0			// Modo baja velocidad
#define NINE_BITS 			0x40			// Modo transmisin 9 bits
#define EIGHT_BITS 			0			// Modo transmisin 8 bits
#define _XTAL_FREQ			4000000			// Frecuencia del oscilador principal

#define RX_PIN TRISC7			// Define el pin RC7 como pin para recepcin de datos
#define TX_PIN TRISC6			// Define el pin RC6 como pin para transmisin de datos


/* MACRO PARA CONFIGURAR EL MDULO USART EN MODO ASNCRONO*/
// BAUD: Velocidad de comunicaciones (9600, 19200, 28800, etc.)
// SPEED: Modo alta velocidad para el genereador de baudios => TRUE = On
// NINE: Utiliza transmission de 9 bits => FALSE=8bit
#define INIT_USART(BAUD,SPEED,NINE)\
	RX_PIN = 1;	\				// Define los pines RC6 y RC7 para poder
	TX_PIN = 1;		  \			// ser utilizados por el mdulo USART
	if (SPEED)SPBRG = ((int)(_XTAL_FREQ/((16UL * BAUD) +16))); \	// Ajusta la velocidad del
	else SPBRG = ((int)(_XTAL_FREQ/((64UL * BAUD) +64)));     	\	// gen. de baudios
	RCSTA = (NINE|0x90);	\		// Carga la configuracin del mdulo receptor
	TXSTA = (SPEED|NINE|0x20)		// Carga la configuracin del mdulo transmisor

#endif

void putch(unsigned char byte);		// Definicin de la funcin putch
unsigned char getche(void);			// Definicin de la funcin getche
unsigned char getch(void);			// Definicin de la funcin getch
#ifndef _SERIAL_H_
#define _SERIAL_H_
#define HIGH_SPEED 			0x04			// Modo alta velocidad
#define LOW_SPEED 			0			// Modo baja velocidad
#define NINE_BITS 			0x40			// Modo transmisin 9 bits
#define EIGHT_BITS 			0			// Modo transmisin 8 bits
#define _XTAL_FREQ			4000000			// Frecuencia del oscilador principal

#define RX_PIN TRISC7			// Define el pin RC7 como pin para recepcin de datos
#define TX_PIN TRISC6			// Define el pin RC6 como pin para transmisin de datos


/* MACRO PARA CONFIGURAR EL MDULO USART EN MODO ASNCRONO*/
// BAUD: Velocidad de comunicaciones (9600, 19200, 28800, etc.)
// SPEED: Modo alta velocidad para el genereador de baudios => TRUE = On
// NINE: Utiliza transmission de 9 bits => FALSE=8bit
#define INIT_USART(BAUD,SPEED,NINE)\
	RX_PIN = 1;	\				// Define los pines RC6 y RC7 para poder
	TX_PIN = 1;		  \			// ser utilizados por el mdulo USART
	if (SPEED)SPBRG = ((int)(_XTAL_FREQ/((16UL * BAUD) +16))); \	// Ajusta la velocidad del
	else SPBRG = ((int)(_XTAL_FREQ/((64UL * BAUD) +64)));     	\	// gen. de baudios
	RCSTA = (NINE|0x90);	\		// Carga la configuracin del mdulo receptor
	TXSTA = (SPEED|NINE|0x20)		// Carga la configuracin del mdulo transmisor

#endif

void putch(unsigned char byte);		// Definicin de la funcin putch
unsigned char getche(void);			// Definicin de la funcin getche
unsigned char getch(void);			// Definicin de la funcin getch