//	A1.2.- interrupts
//	Autores: Jess Mara Corres, Carlos Ruiz Zamarreo y Cndido Bariin
//	Pamplona, Agosto 2016

// CONSTANTES, MACROS Y FUNCIONES PARA LOS PUERTOS DE ENTRADA Y SALIDA DIGITALES

#define GLOBAL				0x000080
#define PERIPHERAL				0x000040
#define INT_T0				0x000020
#define INT_EXT				0x000010
#define INT_PORTB				0x000080
#define INT_T1				0x000100
#define INT_T2				0x000200
#define INT_CCP1				0x000400
#define INT_SSP				0x000800
#define INT_TX				0x001000
#define INT_RX				0x002000
#define INT_AD				0x004000
#define INT_PSP				0x008000
#define INT_CCP2				0x010000
#define	enable_int(value)		INTCON|=value;	\
						PIE1|=((value&0x00FF00)>>8);	\
						PIE2|=((value&0xFF0000)>>16)
#define	disable_int(value)		INTCON&=(~value); \
						PIE1&=(~((value&0x00FF00)>>8)); \
						PIE2&=(~((value&0xFF0000)>>16))
						PIE2&=(~(value>>16))